import re
import os
import sys
import random
import hashlib
import urllib3
import threading
import urllib.parse
import pandas as pd
from abc import ABC
from time import sleep
from sys import stdout
import concurrent.futures
from random import randrange
from datetime import datetime
from core_framework.crawlers import CrawlerBase
urllib3.disable_warnings(urllib3.exceptions.InsecureRequestWarning)
from crawlers_sm.croatia.eoglasna.parser import parse, detalji_sudionik, detalji


api_key = '7c315478c67a270a2d829f1a00f9096c'
site_key = '6LcJFLcUAAAAAAWb8bmUnRGwe9RBS4ADwlu2-VBp'

base = 'https://e-oglasna.pravosudje.hr'
objave_url = '/'.join([base, 'objave-sudova'])
captcha_api = f'http://2captcha.com/in.php?key={api_key}&method=userrecaptcha&googlekey={site_key}&pageurl={objave_url}'


base = 'https://e-oglasna.pravosudje.hr'

main_doc_path = 'E:\TuzbeDocs\\'
today = datetime.today().strftime('%Y%m%d')

server_doc_path = os.path.join('Z:\\', 'oglastrgsud')

# download dokumenata
local_dir_path = os.path.join(main_doc_path, 'download')
local_dir_path_fina = os.path.join(main_doc_path, 'download', 'fina')

local_dir_path_day = os.path.join(main_doc_path, 'downloaddaily')
local_subdir_path_day = os.path.join(main_doc_path, 'downloaddaily', today)

server_dir_path = server_doc_path
server_dir_path_fina = os.path.join(server_doc_path, 'FINA')

date_to = datetime.now().strftime('%Y-%m-%d')
date_from = datetime.now().strftime('%Y-%m-%d')

# ručni odabir perioda ako je potrebno
# date_to = '2019-10-15'
# date_from = '2019-10-15'


class Eoglasna(CrawlerBase, ABC):
    def __init__(self, first_run=True, recheck=None):
        CrawlerBase.__init__(self, base, proxy_type=1)
        self.connect(4)
        self.courts = self.select('SUD', schema='TUZBE')
        self.courts = {row.get('naziv'): row for row in self.courts}
        self.token_id = None
        self.first_run = first_run
        if recheck is not None:
            self.recheck_pages = recheck
        self.recheck_pages2 = {1: [], 2:[]}
        self.flag_120 = False
        self.dir_creator()
        self.connect(1, connect_args={"application_name": "crawlers_sm/croatia/eoglasna/crawler.py/Eoglasna"})

    def done_status(self):
        if self.recheck_pages2.get(1) == [] and self.recheck_pages2.get(2) == []:
            return True
        else:
            return False

    def get_token(self, proc_id=1):
        step_id = 1
        token_id = None
        errors = []
        sha = self.new_request(proc_id=proc_id, protocols=['http'], new=True)
        r = self.requests.get(proc_id)
        r.request_type = 1
        try:
            r.go(captcha_api)
            html = r.response.content
            if not type(html) is dict:
                request_id = None
                id_search = re.search('(\d+)', html.decode())
                if id_search is not None:
                    request_id = id_search.group(1)
                sleep(randrange(10, 15))
                for i in range(10):
                    request_check = f"http://2captcha.com/res.php?key={api_key}&action=get&id={request_id}"
                    r.go(request_check)
                    html_bs = r.response.content
                    if type(html_bs) is dict:
                        err_desc = html_bs.get('RequestError')
                        print(err_desc)
                        sleep(20)
                        continue
                    html = html_bs.text
                    if html == 'CAPCHA_NOT_READY':
                        sleep(10)
                    else:
                        token_id = html.replace("OK|", "")
                        break
            else:
                err_desc = html.get('RequestError')
                errors.append(err_desc)
                # print("get_token", err_desc)
        finally:
            # release proxy back in use if it is not released it will be not be available for that web_base next 30min
            self.release_proxy(sha)

        if token_id is None or token_id == '' or token_id == 'ERROR_CAPTCHA_UNSOLVABLE':
            err_desc = 'could not get token from captcha service'
            errors.append(err_desc)
            # print("get_token2", err_desc)
            return errors

        return token_id

    def gather(self):
        proc_id = 1
        step_id = 0
        no_results = None
        rows_search = None

        vrste_objava = {1: 'noticeSourceType=COURT', 2: 'noticeSourceType=NOTARY_PUBLIC'}

        # rid is source of information it can be eather public notary or court
        for rid, vrsta_objave in vrste_objava.items():

            # first we going to get google token for this page
            while True:
                g_token = self.get_token()
                if type(g_token) is str:
                    break

            last_page = 1

            # get today changes
            sha = self.new_request(proc_id=proc_id, protocols=['https'], new=True)
            r = self.requests.get(proc_id)
            r.request_type = 2
            try:
                g_url = f'https://e-oglasna.pravosudje.hr/objave-sudova?{vrsta_objave}&datePublishedFrom={date_from}&datePublishedTo={date_to}&_g={g_token}'
                r.ses.verify = False
                r.go(g_url)
                html = r.response.content
                if type(html) is dict:
                    err_desc = html.get('RequestError')
                    print("page", vrsta_objave, "gather", err_desc)
                else:
                    # get last page
                    last_page_re = html.find('a', {'title': 'Poslijednja stranica', 'href': True})
                    if last_page_re is not None:
                        last_page_link = last_page_re['href']
                        last_page_n = re.search('page=(\d+)', last_page_link, re.DOTALL | re.MULTILINE | re.IGNORECASE)
                        if last_page_n is not None:
                            last_page = int(last_page_n.group(1))

                    # get total number of court cases specified for current rid search
                    rows_search = re.search('Pronađeno rezultata:\s+<strong>(\d+)</strong>', html.decode(), re.DOTALL | re.MULTILINE | re.IGNORECASE)
                    if rows_search is not None:
                        rows_search = rows_search.group(1)

                    # check is there any data
                    no_results = html.find('em', text=re.compile('Nema rezultata.'))
            finally:
                # release proxy back in use if it is not released it will be not be available for that web_base next 30min
                self.release_proxy(sha)

            if no_results is not None:
                print('Nema rezultata')
                # log it
                return

            print("rid", rid, "last_page", last_page, 'rows', rows_search)
            # check is all rid data downloaded
            # list_data = self.select('eoglasna_pretraga'.upper(), filters={'rid': rid, 'datum_objave': ">={pd.to_datetime(date_to, yearfirst=True)}"})
            # print(list_data)
            # print(len(list_data))
            # exit()
            pages = list(range(1, last_page + 1))

            if self.first_run is False:
                pages = [page for page in pages if page in self.recheck_pages.get(rid)]

            # We can use a with statement to ensure threads are cleaned up promptly
            with concurrent.futures.ThreadPoolExecutor(max_workers=5) as executor:
                # Start the load operations and mark each future with its URL
                future_to_url = {executor.submit(self.load_page, page, rid, vrsta_objave): page for page in pages}
                for future in concurrent.futures.as_completed(future_to_url):
                    url = future_to_url[future]
                    try:
                        data = future.result()
                    except Exception as exc:
                        print('%r generated an exception: %s' % (url, exc))
                    else:
                        self.connect(4)
                        if data is not None:
                            # print(data)
                            for d in data:
                                detalji_objave_link = d.get('detalji_objave_link')
                                if detalji_objave_link is not None:
                                    self.merge('EOGLASNA_RBR', {0: {'detalji_objave_link': detalji_objave_link}}, filters={'detalji_objave_link': detalji_objave_link}, on=['detalji_objave_link'])
                                    # osnovni rezultati pretrage
                                    sha = d.get('sha')
                                    rbr = self.select('EOGLASNA_RBR', filters={'detalji_objave_link': detalji_objave_link})[0].get('rbr')
                                    d.update({'rbr': rbr})
                                    print(d, sha)
                                    self.merge('EOGLASNA_PRETRAGA', {0: d}, filters={'sha': sha})
                            print(rid, 'page is %r gathered rows %d' % (url, len(data)))
                        else:
                            print(url, data)

    def load_page(self, page, rid, vrsta_objave):
        sha = ''
        parsed_data = []
        try:
            # first we going to get google token for this page
            proc_id = threading.current_thread().ident
            print(f"rid {rid} solving page {page} thread_id: {proc_id}")
            while True:
                g_token = self.get_token()
                # print("load_page", g_token)
                if type(g_token) is str:
                    break

            # get today changes
            sha = self.new_request(proc_id=proc_id, protocols=['https'], new=True)
            r = self.requests.get(proc_id)
            r.request_type = 2
            r.ses.verify = False

        except Exception as e:
            err_desc = str(e)
            print("rid", rid, "page", page, "load_page1", err_desc)
            rid_list = self.recheck_pages2.get(rid)
            rid_list.append(page)
            self.release_proxy(sha)
            return parsed_data

        try:
            url = f'https://e-oglasna.pravosudje.hr/objave-sudova?{vrsta_objave}&datePublishedFrom={date_from}&datePublishedTo={date_to}&page={page}&sort=datePublished,desc&_g={g_token}'
            r.go(url)
            html = r.response.content
            if type(html) is dict:
                err_desc = html.get('RequestError')
                print("rid", rid, "page", page, "load_page", err_desc)
                rid_list = self.recheck_pages2.get(rid)
                rid_list.append(page)
                self.bad_proxy(sha, r.proxy_data)
            else:
                parsed_data = parse(html, self.courts, rid)


        finally:
            # release proxy back in use if it is not released it will be not be available for that web_base next 30min
            self.release_proxy(sha)

        return parsed_data

    def dohvat_detalja(self):
        proc_id = 123

        sha = self.new_request(proc_id=proc_id, protocols=['https'], new=True)
        r = self.requests.get(proc_id)
        r.request_type = 2
        r.ses.verify = False

        self.connect(4)
        detalji_lista_unique = []
        detalji_lista = self.select('eoglasna_pretraga'.upper(), filters={'detalji': None}, columns=['rbr', 'detalji_objave_link', 'rid'])
        detalji_sha = []
        for dl in detalji_lista:
            sha = hashlib.sha3_256(str(dl).encode()).hexdigest()
            if sha not in detalji_sha:
                detalji_lista_unique.append(dl)
                detalji_sha.append(sha)

        for data in detalji_lista_unique:
            print(data)
            rbr = data.get('rbr')
            rid = data.get('rid')
            detalj_url = data.get('detalji_objave_link')

            try:
                if detalj_url is not None:
                    detalji_url = ''.join([base, detalj_url])
                    r.go(detalji_url)
                    html = r.response.content
                    if type(r.response_raw) is dict:
                        continue
                    status_code = r.response_raw.status_code
                    ress_not_found = re.search('Resurs nije pronađen', r.response_raw.content.decode(), re.MULTILINE | re.DOTALL | re.IGNORECASE)
                    if status_code == 404 and ress_not_found is not None :
                        self.update('eoglasna_pretraga'.upper(), filters={'rbr': rbr}, values={'detalji': 404})
                    elif type(html) is dict:
                        err_desc = html.get('RequestError')
                        print("detalji_url", detalji_url, "load_page", err_desc)
                        self.release_proxy(sha)
                        sha = self.new_request(proc_id=proc_id, protocols=['https'], new=True)
                    else:
                        # e-oglasna
                        e_oglasna_detalji = detalji(html, rbr, detalj_url, rid)
                        print(e_oglasna_detalji)
                        # key za merge je detalj_url
                        e_oglasna_sudionici = detalji_sudionik(html, rbr, detalj_url)

                        self.merge('eoglasna_detalji'.upper(), {0: e_oglasna_detalji}, filters={'rbr': rbr})
                        if e_oglasna_sudionici:
                            print(e_oglasna_sudionici)
                            self.merge('eoglasna_sudionici'.upper(), e_oglasna_sudionici, filters={'rbr': rbr})
                        self.update('eoglasna_pretraga'.upper(), filters={'rbr': rbr}, values={'detalji': 200})

            except Exception as e:
                print(str(e))
                # release proxy back in use if it is not released it will be not be available for that web_base next 30min
                self.release_proxy(sha)
                sha = self.new_request(proc_id=proc_id, protocols=['https'], new=True)

    def download_dokumenata(self):
        # download part
        download_lista = self.select('v_tuzbe_download', view=True)
        # download part
        self.connect(4)
        download_lista = self.select('v_tuzbe_download', view=True)
        # We can use a with statement to ensure threads are cleaned up promptly
        with concurrent.futures.ThreadPoolExecutor(max_workers=5) as executor:
            # Start the load operations and mark each future with its URL
            future_to_url = {executor.submit(self.download, dl_data): dl_data for dl_data in download_lista}
            for future in concurrent.futures.as_completed(future_to_url):
                url = future_to_url[future]
                try:
                    data = future.result()
                except Exception as exc:
                    print('%r generated an exception: %s' % (url, exc))
                # else:
                #     print(data)

    @staticmethod
    def filemd5(filename, block_size=2 ** 20):
        f = open(filename, errors='ignore')
        md5 = hashlib.md5()
        while True:
            data = f.read(block_size)
            if not data:
                break
            data = data.encode()
            md5.update(data)
        f.close()
        return md5.hexdigest()

    @staticmethod
    def dir_creator():
        dirs = [local_dir_path, local_dir_path_fina, local_dir_path_day, local_subdir_path_day]
        for dir_path in dirs:
            if os.path.isdir(dir_path) is False:
                os.mkdir(dir_path)

    def download(self, data):
        if self.flag_120 is True:
            return

        proc_id = threading.current_thread().ident

        id = data.get('id2')
        rbr = data.get('rbr')
        sud_id = data.get('sud_id')
        dokument_url = data.get('dokument_url')
        nova_oglasna = data.get('nova_oglasna')

        # get today changes
        sha = self.new_request(proc_id=proc_id, protocols=['https'], new=True)
        r = self.requests.get(proc_id)
        r.request_type = 2
        r.ses.verify = False

        try:
            # url = ''.join([base, dokument_url])
            url = dokument_url

            print(url)
            doc_data = r.go(url, download_raw=True)

            if type(doc_data) is not dict:
                if int(doc_data.status_code) > 499:
                    self.update('EOGLASNA_PRETRAGA', {'rbr': rbr}, {'doc_dl': doc_data.status_code})
                    doc_data = {"RequestError": "Page server 500 cant reach document"}

            if type(doc_data) is dict:
                # print("download nije uspio", doc_data)
                err_desc = doc_data.get('RequestError')
                print(err_desc)
            else:
                response_headers = doc_data.headers
                filename, filename2 = None, None
                print(response_headers)
                content_disposition, content_length, content_type = None, 0, None
                if response_headers is not None:
                    content_disposition = response_headers.get('Content-Disposition')
                    filename = re.search('name="(.*?)"', content_disposition)
                    if filename is not None:
                        filename = filename.group(1)

                    content_disposition2 = content_disposition.replace("\\", '')
                    filename2 = re.search("filename.?=.*?''(.*)", content_disposition2)
                    print("filename2", filename2)
                    print("content_disposition2", content_disposition2)
                    if filename2 is not None:
                        filename2 = filename2.group(1)
                        filename2 = urllib.parse.unquote(filename2)

                    content_length = response_headers.get('Content-Length')

                doc_data = doc_data.content
                print(f"doc name: {filename}, content_disposition: {filename} content_length: {content_length} content_type: {content_type} filename2: {filename2}")


                if sud_id == 99999:
                    local_path = local_dir_path_fina
                    server_path = server_dir_path_fina
                else:

                    # if nova_oglasna is not None and nova_oglasna == 1:
                    local_path = os.path.join(local_dir_path, 'nova', str(sud_id))
                    server_path = os.path.join(server_dir_path, 'nova', str(sud_id))
                    # else:
                    #     local_path = os.path.join(local_dir_path, 'stara', str(sud_id))
                    #     server_path = os.path.join(server_dir_path, 'stara', str(sud_id))

                if os.path.exists(local_path) is False:
                    os.makedirs(local_path)

                if filename is not None:

                    docExtension_idx = filename.rfind(".")

                    if docExtension_idx == -1:
                        print('Nema ekstenzija ' + filename , url)
                        self.update('EOGLASNA_PRETRAGA', {'rbr': rbr}, {'doc_name': filename, 'doc_filename': filename2, 'doc_ext': 'no ext', 'doc_dl': 902})

                    else:
                        docExtension = filename[docExtension_idx + 1:]

                        if len(docExtension) > 6:
                            self.update('EOGLASNA_PRETRAGA', {'rbr': rbr}, {'doc_name': filename, 'doc_filename': filename2, 'doc_ext': docExtension, 'doc_dl': 901})

                        if len(docExtension) < 6:

                            filename_short = str(id) + '.' + docExtension

                            # local dir path
                            filename_full = os.path.join(local_path, filename_short)
                            # local dir path today
                            filename_full_today = os.path.join(local_subdir_path_day, filename_short)
                            # server dir path
                            filename_server_full = os.path.join(server_path, filename_short)

                            fileLen = len(doc_data)

                            stdout.write("\rdownloading: {}, file lenght:{}".format(filename_full, fileLen))

                            if fileLen > 266:
                                # writing files
                                # writing = [filename_full, filename_full_today, filename_server_full]
                                writing = [filename_full, filename_full_today]
                                for path in writing:
                                    with open(path, 'wb') as f:
                                        f.write(doc_data)

                                hashmd5 = self.filemd5(filename_full)
                                insert_data = {0: {'date_created': datetime.now(), 'len_download': fileLen,
                                                   'file_download': filename_short, 'httpstatus': 200,
                                                   'id_objava': id, 'hashmd5': hashmd5}}

                                print("insert_data", insert_data)

                                try:
                                    self.update('EOGLASNA_PRETRAGA', {'rbr': rbr}, {'doc_name': filename, 'doc_filename': filename2, 'doc_ext': docExtension, 'doc_dl': 200})
                                    self.insert('OBJAVA_FILES', insert_data, primary_key='id_objava', schema='tuzbe')
                                except Exception as e:
                                    exc_type, exc_obj, exc_tb = sys.exc_info()
                                    fname = os.path.split(exc_tb.tb_frame.f_code.co_filename)[1]
                                    e = '======================================\n Oglasna download ERRORS: \n +error type: %s \n +py location: %s \n +error line: %s \n +error description: %s \n======================================' % (str(exc_type), os.path.abspath(fname), exc_tb.tb_lineno, str(e))
                                    print(e)

        except Exception as e:
            exc_type, exc_obj, exc_tb = sys.exc_info()
            fname = os.path.split(exc_tb.tb_frame.f_code.co_filename)[1]
            error_description = str(e)
            if error_description.find('No space left on device'):
                self.flag_120 = True
            e = '======================================\n Oglasna download ERRORS: \n +error type: %s \n +py location: %s \n +error line: %s \n +error description: %s \n url: %s \n======================================' % (str(exc_type), os.path.abspath(fname), exc_tb.tb_lineno, str(e), url)
            print(e)

        finally:
            # release proxy back in use if it is not released it will be not be available for that web_base next 30min
            self.release_proxy(sha)

        sleep(random.randrange(10, 15))


if __name__ == '__main__':
    """aplikacija nije optimizirana"""

    # # dohvat rezultata pretrage
    # c = 0
    # recheck = dict()
    # while True:
    #     c += 1
    #     if c == 1:
    #         api = Eoglasna()
    #     else:
    #         api = Eoglasna(first_run=False, recheck=recheck)
    #
    #     api.gather()
    #     status = api.done_status()
    #     print("all parsed", status)
    #     print(api.recheck_pages2)
    #     recheck = api.recheck_pages2.copy()
    #     if status is True:
    #         api.proc('eoglasna_insert_data'.upper())
    #         break

    api = Eoglasna()

    # api.connect(4)
    # api.proc('eoglasna_insert_data'.upper())

    # download dokumenata
    api.download_dokumenata()

    # dohvat detalja
    api.dohvat_detalja()

