import pandas as pd
from core_framework.db_engine import DbEngine

schema = 'alsu'


def mssql_to_pstgr():
    """serves for first migration of data from mssql to postgre"""
    db = DbEngine()
    db.connect(3, echo=False)
    x = db.select('alsu_detalji')
    pstgr_data = {}
    mssql_data = pd.DataFrame.from_records(x)
    mssql_to_pstgr = {'adresa': 'address', 'dat_pro': 'archive', 'datotv': 'decision_date',
                      'djelatnost': 'activity', 'grad': 'city', 'mb': 'registry_number',
                      'naziv': 'company_name', 'opcina': 'municipality', 'pib': 'vat_number',
                      'pravnaforma': 'legal_form', 'statstecpost': 'bankruptcy_status', 'sud': 'court',
                      'sudac': 'judge', 'sudrj': 'decision', 'upravnik': 'manager', 'companyid': 'companyid',
                      'date_created': 'date_created', 'link_id': 'link_id', 'sha': 'sha'}

    mssql_columns = list(mssql_data.columns)
    pstgr_columns = [mssql_to_pstgr.get(col) for col in mssql_columns]
    mssql_data.columns = pstgr_columns
    [pstgr_data.update({len(pstgr_data): row}) for row in mssql_data.to_dict('records')]

    db = DbEngine()
    db.connect(4, echo=False)
    db.merge('data', pstgr_data, filters={}, on=['sha'], schema=schema)

mssql_to_pstgr()