import hashlib
from abc import ABC
from core_framework.crawlers import CrawlerBase
from datetime import datetime
from time import sleep

# start_time = datetime.now()
# sleep(20)
# diff_time = (datetime.now() - start_time).total_seconds()
#
# print('diff_time', diff_time)
# exit()

base = 'porezni_duznici_CRO'


class PorezniDuznici(CrawlerBase, ABC):
    def __init__(self):
        CrawlerBase.__init__(self, base)

    def calc_sha(self):
        self.connect(4)
        list = self.select('porezni_duznici_sha'.upper(), view=True)
        for row in list:
            data = {}
            cols = ['NAZIV', 'ZUP', 'NASELJE', 'DPDV', 'DPD', 'DPPD', 'DPZOO', 'TROSARINA', 'DPPN', 'CARINA', 'DPNK', 'UKUPNO_DUG', 'NAPOMENA', 'DATE_UPLATA_DIO', 'DAT_OBJAVE', 'DAT_OBRADE']
            for col in cols:
                row_col = row.get(col.lower())
                data.update({col: row_col})

            sha = hashlib.sha3_256(str(data).encode()).hexdigest()
            data.update({'SHA': sha})
            row_id = row.get('id2')
            print(row_id, data)

            self.update('POREZNI_DUZNICI', {'id': row_id}, {'sha': sha})




if __name__ == '__main__':
    api = PorezniDuznici()
    api.calc_sha()