import hashlib
import pandas as pd
from core_framework.db_engine import DbEngine
import dateutil.parser

from datetime import datetime, timedelta
import sys


class NbsZabraneUsklada(DbEngine):
    def __init__(self):
        DbEngine.__init__(self)

    def main(self):
        self.connect(1, connect_args={"application_name": "nbs/enforced_collection/crawler.py postgresql_conn"})
        bans = self.select('blockade_bans', filters={'archive': None}, schema='nbs_pn')

        self.connect(2, archive_date='dat_pro')
        checked = 0
        for ban in bans:
            registry_number_ban = ban.get('registry_number')
            ban_data = self.select('NBS_PN_ZABRANE', filters={'mb': registry_number_ban, 'dat_pro': None})
            replace_ban = {'registry_number': 'mb', 'ban_date': 'dat_zabr', 'archive': 'dat_pro', 'sha': 'sha', 'date_created': 'date_created'}
            if not ban_data:
                new_ban = {}
                for k, v in ban.items():
                    col_name = replace_ban.get(k)
                    if col_name is not None:
                        new_ban.update({col_name: v})

                merge_status = self.merge('NBS_PN_ZABRANE', {0: new_ban}, filters={'dat_pro': None, 'mb': registry_number_ban}, on=['sha'])
            checked += 1
            sys.stdout.write(f"\r {checked}/{len(bans)}")


if __name__ == '__main__':
    api = NbsZabraneUsklada()
    api.main()