import re
import hashlib
from bs4 import BeautifulSoup

with open('eoglasna_parse.html', 'r', encoding='utf-8') as f:
    html = f.read()
    html = BeautifulSoup(html, 'lxml')
    result_selection = html.find('section', {'class': 'rezultati'})
    ul = result_selection.find('ul')
    rows = list()
    lis = ul.find_all('li')
    for li in lis:

        # broj rješenja
        broj_rjesenja = None
        search_link_broj = li.find('a', {'title': 'Sve objave vezane za ovaj premet'})
        if search_link_broj is not None:
            broj_rjesenja = search_link_broj.text.strip()

        # detalji objave
        detalji_objave_link = None
        detalji_objave_text = None
        search_detalji = li.find('a', {'title': 'Detalji objave'})
        if search_detalji is not None:
            detalji_objave_link = search_detalji['href']
            detalji_objave_text = search_detalji.text.strip()

        # naziv suda
        naziv_suda = None
        search_sud = li.find('a', {'title': 'Sve objave ovog suda'})
        if search_sud is not None:
            naziv_suda = search_sud.text.strip()

        # vrsta rješenja
        vrsta_rjesenja = None
        search_badge = li.find('span', {'class': 'badge'})
        if search_badge is not None:
            vrsta_rjesenja = search_badge.text.strip()

        # Sudionici
        sudionici, sudionici_sha = list(), list()
        divs = li.find_all('div')
        divs = [div for div in divs if re.search('Sudionici', div.text, re.DOTALL |re.MULTILINE | re.IGNORECASE)]
        for div in divs:
            dblock_search = div.find_all('div', {'class': 'd-block'})
            for dblock in dblock_search:
                sha_dblock = hashlib.sha3_256(dblock.encode()).hexdigest()
                if sha_dblock not in sudionici_sha:
                    sudionik, oib, vrsta_sudionika = None, None, None
                    sudionik_search = dblock.find('span', {'data-content': 'Sudionici predmeta'})
                    if sudionik_search is not None:
                        sudionik = sudionik_search.text
                    oib_search = dblock.find('small', {'data-content': 'OIB sudionika'})

                    if oib_search is not None:
                        oib_numbers = re.search("(\d+)", dblock.text)
                        if oib_numbers is not None:
                            oib = oib_numbers.group(1)

                    duznik_search = dblock.find('span', {'data-content': 'Sudionik je dužnik'})
                    if duznik_search is not None:
                        vrsta_sudionika = duznik_search.text

                    sudionici.append({'sudionik': sudionik, 'oib': oib, 'vrsta_sudionika': vrsta_sudionika})
                    sudionici_sha.append(sha_dblock)

        # Datum objave
        datum_objave = None
        datum_objave_search = re.search('<small class="text-muted d-block">Datum i vrijeme objave</small>.*?<div class="d-block"><span class="m-date">(.*?)</span></div>', li.decode(), re.MULTILINE | re.IGNORECASE | re.DOTALL)
        if datum_objave_search is not None:
            datum_objave = datum_objave_search.group(1)

        # Posljedni datum objave
        datum_brisanja = None
        datum_brisanja_search = re.search('<small class="text-muted d-block">Posljednji datum objave</small>.*?<div class="d-block"><span class="m-date">(.*?)</span></div>', li.decode(), re.MULTILINE | re.IGNORECASE | re.DOTALL)
        if datum_brisanja_search is not None:
            datum_brisanja = datum_brisanja_search.group(1)

        # Dokument link
        doc_link = None
        doc_link_search = li.find('a', {'data-content': 'Preuzimanje dokumenta objave', 'href': True})
        if doc_link_search is not None:
            doc_link = doc_link_search['href']

        print({'broj_rjesenja': broj_rjesenja, 'detalji_objave_link': detalji_objave_link,
               'detalji_objave_text': detalji_objave_text, 'vrsta_rjesenja': vrsta_rjesenja,
               'search_sud': naziv_suda, 'datum_objave': datum_objave,
               'datum_brisanja': datum_brisanja, 'doc_link': doc_link})

        print({'sudionici': sudionici})

