from sys import stdout
import pandas as pd
from time import sleep
from core_framework.db_engine import DbEngine


class ProxyServer(DbEngine):
    def __init__(self):
        DbEngine.__init__(self)

    def proxy_stats(self):
        self.connect()
        while 1:
            proxies = self.select('proxy_list', filters={'disabled': 0, 'protocols':True}, columns = ['ip', 'protocols'])
            df = pd.DataFrame.from_records(proxies).groupby(['protocols']).agg(['count'])['ip']
            data = df.to_dict()
            stdout.write(f'\rproxy_stats: {data}')
            sleep(30)


if __name__ == '__main__':
    print('''
+-----------------------------------+
|         Proxy list Status         |
+-----------------------------------+
    ''')
    api = ProxyServer()
    api.proxy_stats()