import socket
import pickle
from abc import ABC
from datetime import datetime, timedelta
from time import sleep


try:
    from core_framework.db_engine import DbEngine
    from core_framework.settings import proxy_path
except:
    from db_engine import DbEngine
    from settings import proxy_path

def load_proxy_server_data():
    with open(proxy_path, 'rb') as fr:
        data = pickle.loads(fr.read())
        proxy_server = data.get("proxy_server")
    return proxy_server


class ProxyClient(DbEngine, ABC):
    def __init__(self, web_base):
        DbEngine.__init__(self)
        self.host, self.port = load_proxy_server_data()
        self.web_base = web_base
        self.last_tic = {}
        self.connect(connect_args={"application_name": "proxy_client.py/ProxyClient"})

    def send_request(self, data):
        return_data = None
        while 1:
            sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
            production_host = (self.host, self.port)
            test_host = ('192.168.16.86', 666)
            try:
                sock.connect(production_host)
                sock.sendall(data)
                # Receive data from the server, unpickle it and close connection
                return_data = sock.recv(1024)
                return_data = pickle.loads(return_data)
            except Exception as global_err:
                print(f"Exception during sending request to ditribution server on location {production_host}. Retrying in 10 sec")
                self.host, self.port = load_proxy_server_data()
                sleep(10)
                continue
            finally:
                sock.close()
            break
        return return_data


if __name__ == '__main__':
    api = ProxyClient('testenv')
    data = pickle.dumps({'command': 'get proxy', 'web_base': api.web_base, 'proxy_type': 'public', 'website': 'testenv', 'protocols': 'https'})
    api.send_request(data)
