import re
import requests
from bs4 import BeautifulSoup

base_url = 'https://sudreg.pravosudje.hr'
objave_sudreg = '/'.join([base_url, 'registar', 'f?p=150:13:0::NO:RP::'])
post_data = '/'.join([base_url, 'registar', 'wwv_flow.accept'])

timeout = 60
start_date = '09.12.2019'
end_date = '14.12.2019'
rows_per_page = 15


def fetch_data():
    total_records = None
    try:
        ses = requests.session()
        ses.headers.update({'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:71.0) Gecko/20100101 Firefox/71.0'})
        r = ses.get(objave_sudreg, timeout=timeout)
        soup = BeautifulSoup(r.content, 'lxml')

        payload = {'p_flow_id': 150, 'p_flow_step_id': 13, 'p_t02': 'app_begins',
                   'p_t06': 0, 'p_t07': 'D', 'p_t10': start_date, 'p_t11': end_date,'p_t12': rows_per_page,
                   'p_t13': 0,  'p_request': 'P13_PRETRAZI'}

        form_keys = ['p_instance', 'p_page_submission_id', 'p_t16', 'p_page_checksum']
        for form_key in form_keys:
            input = soup.find('input', {'name': form_key})
            if input is not None:
                payload.update({form_key: input['value']})

        inputs = soup.find_all('input', {'type': 'hidden'})
        p_arg_names = []
        for input in inputs:
            parent = input.parent
            if parent.name == 'td':
                input_number = parent.find_all('input', {'name': re.compile('p_t\d+')})
                arg_name = parent.find_all('input', {'name': 'p_arg_names'})
                if not input_number:
                    input_number = parent.find_all('select', {'name': re.compile('p_t\d+')})

                for i in range(0, len(input_number)):
                    input_number_name = input_number[i]['name']
                    arg_name_data = arg_name[i]['value']
                    input_number_data = int(re.search('(\d+)',input_number_name, re.DOTALL | re.IGNORECASE |re.MULTILINE).group(1))
                    p_arg_names.append(arg_name_data)
        payload.update({'p_arg_names': p_arg_names})

        ses.headers.update({'Content-Type': 'application/x-www-form-urlencoded'})
        r = ses.post(post_data, data=payload, timeout=timeout)

        soup = BeautifulSoup(r.content, 'lxml')
        span = soup.find('span', text=re.compile('redak \d+ - \d+ od \d+'))
        if span is not None:
            total_records = re.search('redak \d+ - \d+ od (\d+)', span.text)
            if total_records is not None:
                total_records = int(total_records.group(1))

        return total_records
    except Exception as e:
        return str(e)


if __name__ == '__main__':
    total_records = fetch_data()
    if type(total_records) is int:
        print("total_records", total_records)
    else:
        print('error occurred', total_records)